require.paths.unshift(__dirname + '/../../dep');

var Step = require('step'),
    underscore = require('underscore'),
    EventEmitter = require('events').EventEmitter;

Stepper = exports.Stepper = function() {
    EventEmitter.call(this);

    var steps = [];
    var self = this;

    this.add = function(step) {
        steps.push(step);
    };
    
    this.walk = function() {
        steps.push(function(err, val) {
            if (err) {
                self.emit('error', err);
            }
            self.emit('end', val);
        });
        Step.apply(null, steps);
    };
    
};
Stepper.prototype = Object.create(EventEmitter.prototype);

Grouper = exports.Grouper = function() {
    EventEmitter.call(this);

    var steps = [];
    var self = this;

    this.add = function(step) {
        steps.push(step);
    };
    
    this.walk = function() {
        var groupSteps = [];
        groupSteps.push(function prime() {
            return 1;
        });
        groupSteps.push(function(err, val) {
            if (err) { throw err; }
            var group = this.group();
            _(steps).each(function(step) {
                step(group());
            });
        });
        groupSteps.push(function finale(err, vals) {
            if (err) {
                self.emit('error', err);
            } else {
                self.emit('end', vals);
            }
        });
        Step.apply(null, groupSteps);
    };
};
Grouper.prototype = Object.create(EventEmitter.prototype);
